#ifndef SANEINTERFACE_H
#define SANEINTERFACE_H

#include  <devices/scanner.h>

struct OptionInfo
{
  int   oi_saneNum;
  char* oi_name;
  void* oi_specialInfo;
  SANE_Option_Descriptor* (*oi_getDescr)(SANE_Handle handle,SANE_Int option);
  SANE_Status (*oi_getValue)(SANE_Handle handle,SANE_Int option,void* val,ULONG* flags);
  SANE_Status (*oi_setValue)(SANE_Handle handle,SANE_Int option,void* val,ULONG* flags);
};

extern char*  versionString;
extern double pixelPerMM;
extern int    simulateThreshold;

SANE_Status saneGetDevices(SANE_Device*** device_list,SANE_Bool local_only);
SANE_Status saneOpen(SANE_String_Const devicename,SANE_Handle* handle, char* firmware);
void        saneClose(SANE_Handle handle);
SANE_Status saneGetParameters(SANE_Handle handle,SANE_Parameters * params);
SANE_Status saneStart(SANE_Handle handle);
SANE_Status saneRead(SANE_Handle handle,SANE_Byte* data,SANE_Int max_length,SANE_Int* length);
void        saneStop(SANE_Handle handle);

struct OptionInfo* getOption(SANE_Handle handle,OptionId id);

#endif /* SANEINTERFACE_H */
