#ifndef  INSTRUMENT_INSTRUMENT_H
#define  INSTRUMENT_INSTRUMENT_H

#ifndef  EXEC_TYPES_H
#include <exec/types.h>
#endif

// #ifndef EXEC_LIBRARIES_H
// #include <exec/libraries.h>
// #endif
// 
// #ifndef EXEC_DEVICES_H
// #include <exec/devices.h>
// #endif
// 
// #ifndef EXEC_IO_H
// #include <exec/io.h>
// #endif

/*-------------------------------------------------------------------
//
//      Startup message
//
*/
struct StartUpMsg
{
  struct Message  msg;
  struct Unit*    unit; 
  char*           devName;
  int             devUnit;
};

/*-------------------------------------------------------------------
//
// Instrument IO same as IOStdReq except for the io_Unit field
// This is changed to a double pointer
//
*/
#pragma pack(2)

struct InstrumentIO
{
  struct  Message    io_Message;
  struct  Device*    io_Device;  /* device node pointer           */
  struct  Unit**     io_Unit;    /* unit user (driver private)    */
  UWORD   io_Command;	           /* device command */
  UBYTE   io_Flags;
  BYTE    io_Error;		           /* error or warning num */
  ULONG   io_Actual;		         /* actual number of bytes transferred */
  ULONG   io_Length;		         /* requested number bytes transferred*/
  APTR    io_Data;		           /* points to data area */
  ULONG   io_Offset;		         /* offset for block structured devices */
};

#pragma pack()

/* Private commands  - don't use  */
#define FCMD_OPEN     0x7ff0
#define FCMD_CLOSE    0x7ff1
#define FCMD_ABORT    0x7ff2

extern void UnitMain(struct Unit *Unit,char* devName,int devUnit);
extern BOOL QuickIO(struct InstrumentIO *ior);

#endif
