/*
 * Special Amiga routine for test purpose
 *
 */

#include <exec/types.h>

#include <stdio.h>
#include <stdlib.h>

#include <SaneScsi.h>


static void dump(UBYTE* data,int len)
{
  int i;

  if( len > 20 )
    len = 20;
  for( i = 0 ; i < len ; i++)
    KPrintF("%3.2X",data[i]);
}

void _dumpSCSIinfo(int fd)
{
  struct scsiHandler* hd = (struct scsiHandler*)fd;

  KPrintF("\nio_Actual = %d\n",hd->io_Len);
  KPrintF("io_Error = %d\n",hd->io_Status);

  KPrintF("\nstruct SCSICmd\n{\n");
  KPrintF(" scsi_Data = ");
  dump((UBYTE*)hd->Cmd.scsi_Data,hd->Cmd.scsi_Actual);
  KPrintF("\n");
  KPrintF(" scsi_Length = %d\n",hd->Cmd.scsi_Length);
  KPrintF(" scsi_Actual = %d\n",hd->Cmd.scsi_Actual);
  KPrintF(" scsi_Command = ");
  dump(hd->Cmd.scsi_Command,hd->Cmd.scsi_CmdLength);
  KPrintF("\n");
  KPrintF(" scsi_CmdLength =  %d\n",hd->Cmd.scsi_CmdLength);
  KPrintF(" scsi_CmdActual =  %d\n",hd->Cmd.scsi_CmdActual);
  KPrintF(" scsi_Flags = %4.4X\n",hd->Cmd.scsi_Flags);
  KPrintF(" scsi_Status = %d\n",hd->Cmd.scsi_Status);
  KPrintF(" SenseData = ");
  dump(hd->Cmd.scsi_SenseData,hd->Cmd.scsi_SenseLength);
  KPrintF("\n");
  KPrintF(" scsi_SenseLength = %d\n",hd->Cmd.scsi_SenseLength);
  KPrintF(" scsi_SenseActual = %d\n",hd->Cmd.scsi_SenseActual);
  KPrintF("}\n\n");
}


