/*

    #?.library/device friendly form of memory functions
     -- rzookol --

*/


#include <proto/exec.h>
#include <sys/types.h>

struct memheader
{
    int size;
};


int wall_size = 0;

void *malloc(size_t size)
{
	struct memheader *m;
    m = AllocMem(size+size%4 + sizeof(*m)+8, MEMF_ANY|MEMF_SEM_PROTECTED);
	
    if (m)
    {
		if (wall_size == 8)
		{
			char *a = (char*) m;
			a += sizeof(*m)+ size+size%4 ;
			a[0]   = 'D';
			a[1] = 'U';
			a[2] = 'P';
			a[3] = 'A';
			a[4] = '1';
			a[5] = '2';
			a[6] = '3';
			a[7] = '4';
		}
    	m->size = size+size%4;
           // KPrintF("size: %d %d %d\n",  m, ((char *)m) + sizeof(*m), sizeof(struct memheader ));
    	return ((char *)m) + sizeof(*m);
    
    }

    return NULL;
}

void *calloc(int nmemb, size_t size)
{
    struct memheader *m = AllocMem(size*nmemb + sizeof(*m)+8, MEMF_ANY|MEMF_CLEAR|MEMF_SEM_PROTECTED);
    if (m)
    {
		if (wall_size == 8)
		{
			char *a = (char*) m;
			a += sizeof(*m)+ size*nmemb+size%4 ;
			a[0] = 'D';
			a[1] = 'U';
			a[2] = 'P';
			a[3] = 'A';
			a[4] = '1';
			a[5] = '2';
			a[6] = '3';
			a[7] = '4';
		}	
    	m->size = size*nmemb;
    	return ((char *)m) + sizeof(*m);
    }

    return NULL;
}


void free(void *a)
{
    struct memheader *m;

    if (a)
    {	
		m =  (struct memheader *)(((unsigned char*)a) - sizeof(*m));
		
		if (wall_size == 8)
		{
			char *b;
			b = (char*) m;
			b += m->size + sizeof(*m);
			KPrintF("%c%c%c%c%c%c%c%c\n", b[0], b[1], b[2], b[3], b[4], b[5], b[6], b[7]);
		}
    //	  KPrintF("size: %d %d %d\n",  m->size, m->size + sizeof(*m), sizeof(struct memheader ));
    	FreeMem(m, m->size + sizeof(*m)+8);
    }
}

void *realloc (void* ptr, size_t size)
{
    struct memheader *dst;
    struct memheader *src;

    // if ptr is not NULL
    if (ptr)
    {
        src = (struct memheader *)(((unsigned char*)ptr) - sizeof(*src));

 	// if new memory block is bigger
    	if (((struct memheader *)src)->size < size )
    	{
            //KPrintF("realloc size: %d\n", size);
            if((dst = (struct memheader *)malloc(size)))
            {
    		CopyMem(ptr, dst, ((struct memheader *)src)->size);
    		free(ptr);
            }

            // return new memory block
    	    return dst;
    	}

        // size == 0 so free block
    	if (!size)
        {
            free(ptr);
            ptr = NULL;
        }

        return ptr;
    }

    // ptr is NULL
    dst = (struct memheader *)malloc(size);
    return dst;

}
   /*

void exit(void)
{

}    */
