//
// Mustek_usb driver
//

#include <proto/exec.h>
#include <exec/types.h>
#include <sane/sane.h>
#include <sane/saneopts.h>
#include <devices/scanner.h>
#include <math.h>
#include <string.h>
#include <clib/debug_protos.h>
#include "SaneInterface.h"

static int modeDepth[10] = {0, };
static int features[10] = {0, };
static int brightnessValues[] = {60,40,20,0,-20,-40,-60};
static SANE_Option_Descriptor* getSourceDescr(SANE_Handle handle, SANE_Int option);
struct FujitsuInfo
{
  OptionId          ac_id;
  struct OptionInfo ac_info;
} 
info[] =
{
    {ID_SCANMODE,       {0,SANE_NAME_SCAN_MODE,        modeDepth,getSourceDescr,NULL,NULL}},
    {ID_TL_X,           {0,SANE_NAME_SCAN_TL_X,             NULL,NULL,NULL,NULL}},
    {ID_TL_Y,           {0,SANE_NAME_SCAN_TL_Y,             NULL,NULL,NULL,NULL}},
    {ID_BR_X,           {0,SANE_NAME_SCAN_BR_X,             NULL,NULL,NULL,NULL}},
    {ID_BR_Y,           {0,SANE_NAME_SCAN_BR_Y,             NULL,NULL,NULL,NULL}},
    {ID_RESOLUTION,     {0,SANE_NAME_SCAN_RESOLUTION,       NULL,NULL,NULL,NULL}},
	{ID_THRESHOLD,      {0,SANE_NAME_THRESHOLD,             NULL,NULL,NULL,NULL}},
	{ID_BRIGHTNESS,     {0,SANE_NAME_BRIGHTNESS,            NULL,NULL,NULL,NULL}},
	{ID_SCAN_SOURCE,    {0,SANE_NAME_SCAN_SOURCE,       features,getSourceDescr,NULL,NULL}},
	{ID_CONTRAST,       {0,SANE_NAME_CONTRAST,              NULL,NULL,NULL,NULL}},
    {ID_DUPLEXOFFSET,   {0,"duplexoffset" ,                 NULL,NULL,NULL,NULL}},
	{ID_PAGEWIDTH,      {0,SANE_NAME_PAGE_WIDTH,            NULL,NULL,NULL,NULL}},
	{ID_PAGEHEIGHT,   	{0,SANE_NAME_PAGE_HEIGHT,           NULL,NULL,NULL,NULL}},
    {ID_NONE,           {0,NULL,                            NULL,NULL,NULL,NULL}}
};



static SANE_Option_Descriptor* getSourceDescr(SANE_Handle handle, SANE_Int option)
{
    SANE_Option_Descriptor *sod = sane_get_option_descriptor(handle, option);
	
	if (!strcmp(sod->name,  SANE_NAME_SCAN_SOURCE))
	{
		int i;
		for (i=0; sod->constraint.string_list[i]; i++)
		{
			if(strcmp(sod->constraint.string_list[i], "Flatbed"))
			{
				features[i] = FEATURE_ADF;
			}
			else
			{
				features[i] = FEATURE_NONE;
			}
		}
	}
	else
	if (!strcmp(sod->name,  SANE_NAME_SCAN_MODE))
	{
		int i;
		for (i=0; sod->constraint.string_list[i]; i++)
		{
			if(!strcmp(sod->constraint.string_list[i], SANE_VALUE_SCAN_MODE_LINEART))
			{
				modeDepth[i] = 1;
			
			}
			else if(!strcmp(sod->constraint.string_list[i], SANE_VALUE_SCAN_MODE_HALFTONE))
			{
				modeDepth[i] = 1;
			}
			else if(!strcmp(sod->constraint.string_list[i], SANE_VALUE_SCAN_MODE_GRAY))
			{
				modeDepth[i] = 8;
			}
			else
				modeDepth[i] = 24;
			
			KPrintF("%d -    -      - %s\n", i, sod->constraint.string_list[i]);
		}
	}
	return sod;
}



struct OptionInfo* getOption(SANE_Handle handle, OptionId id)
{
  int i = 0;

  while( (info[i].ac_id != ID_NONE) && (info[i].ac_id != id) )
    i++;
    
  if( info[i].ac_id == id )
    return &info[i].ac_info;
  else
    return NULL;
}


